KDE 4.7 PyKDE API Reference

- KDE's Python API

# KAccelGen Namespace Reference

`from PyKDE4.kdeui.KAccelGen import *`

## Detailed Description

Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection.

NOTE: When this file speaks of "accelerators", we really mean accelerators as defined by the KDE User Interface Guidelines. We do NOT mean "shortcuts", which are what's handled by most other KDE libraries with "accel" in the name.

In the Qt library, the mechanism for adding a keyboard accelerator to a menu item is to insert an '&' before the letter. Since we usually don't want to disturb the original collection, the idiom in these functions is to populate a "target" QStringList parameter with the input collectin's QStrings, plus possibly some added '&' characters.

That is the mechanism. Here is the policy, in order of decreasing importance (it may seem like these are implementation details, but IMHO the policy is an important part of the interface):

1. If the string already contains an '&' character, skip this string, because we consider such strings to be "user-specified" accelerators.

2. No accelerator may clash with a previously defined accelerator, including any legal (alphanumeric) user-specified accelerator anywhere in the collection

3. Prefer alphanumerics at the start of the string.

4. Otherwise, prefer alphanumerics at the start of a word.

5. Otherwise, choose any alphanumeric character not already taken. If no such character is available, give up & skip this string.

A typical use of these functions would be to automatically assign accelerators to a dynamically populated popup menu. For example, the core code was written to automatically set accelerators for the "Load View Profile" popup menu for Konqueror. We quickly realized that it would be useful to make this facility more generally available, so I abstracted it out into a set of templates.

TODO:

+ Add sugar functions for more collections.

+ Add more Deref classes so that we can access a wider variety of collections.

## Functions
| generate (QStringList source, QStringList target)
bool | isLegalAccelerator (QString str, int index)

## Function Documentation

generate | ( | QStringList | source,
|  | QStringList | target
| ) |  |  |

Convenience function; generates accelerators for all the items in a QStringList.

Parameters:

  | source | Strings for which to generate accelerators
  | target | Output for accelerator-added strings

bool isLegalAccelerator | ( | QString | str,
|  | int | index
| ) |  |  |

Helper to determine if the given offset in the string could be a legal alphanumeric accelerator.

Parameters:

  | str | base string
  | index | offset to check